From d1df4c76212b07f3097122cb07781094a63ad9a0 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 26 2020 04:38:16 +0000
Subject: [PATCH 1572/2232] Include <iterator> for input_iterator_tag


---

diff --git a/gen/src/builtin.rs b/gen/src/builtin.rs
index 8e6744e..8741e2d 100644
--- a/gen/src/builtin.rs
+++ b/gen/src/builtin.rs
@@ -59,6 +59,7 @@ pub(super) fn write(out: &mut OutFile) {
     }
 
     if builtin.rust_slice {
+        include.iterator = true;
         include.type_traits = true;
         builtin.friend_impl = true;
     }
@@ -71,6 +72,7 @@ pub(super) fn write(out: &mut OutFile) {
 
     if builtin.rust_vec {
         include.array = true;
+        include.iterator = true;
         include.new = true;
         include.type_traits = true;
         include.utility = true;
diff --git a/gen/src/include.rs b/gen/src/include.rs
index cf718da..b47cc23 100644
--- a/gen/src/include.rs
+++ b/gen/src/include.rs
@@ -26,6 +26,7 @@ pub struct Includes<'a> {
     pub cstdint: bool,
     pub cstring: bool,
     pub exception: bool,
+    pub iterator: bool,
     pub memory: bool,
     pub new: bool,
     pub string: bool,
@@ -81,6 +82,9 @@ pub(super) fn write(out: &mut OutFile) {
     if include.exception {
         writeln!(out, "#include <exception>");
     }
+    if include.iterator {
+        writeln!(out, "#include <iterator>");
+    }
     if include.memory {
         writeln!(out, "#include <memory>");
     }
diff --git a/include/cxx.h b/include/cxx.h
index ed571f0..5725be9 100644
--- a/include/cxx.h
+++ b/include/cxx.h
@@ -4,6 +4,7 @@
 #include <cstdint>
 #include <exception>
 #include <iosfwd>
+#include <iterator>
 #include <new>
 #include <stdexcept>
 #include <string>

